#!/bin/bash
#wangtingwei
base_package_workspace=/data/package    #打包工作的项目目录
seetaas_workspace=/data/package/seetaas #打包工作目录中的子目录seetaas项目
archive_package_workspace=/data/archive   #打包后压缩归档路径
date=`date +%F-%H-%M`
go_proxy_server=http://goproxy.seetatech.com
oss_path=/root/ossfs
oss_project_name=private_archive


seetaas_deploy_archive=$1
private_apt_debs=$2
configmap_kpl_archive=$3
private_images_archive=$4


autodl_core_branch=$5
kpl_frontend_branch=$6
kpl_backend_branch=$7
kpl_stream_branch=$8
kpl_launcher_branch=$9
kpl_version=${10}
kpl_iot_branch=${11}
kpl_edu_branch=${12}





sed_proxy()
{
find $seetaas_workspace -maxdepth 3  -type f -name Makefile |xargs sed -i s@go_proxy_server@$go_proxy_server@g
}

autodl_core(){
echo "清空seetaas旧的工作空间"
rm -rf $seetaas_workspace
echo "为后端创建src目录"
test -d $seetaas_workspace/src || mkdir $seetaas_workspace/src/ -pv
echo "拉取$autodl_core_branch分支的autodl-core代码,并且编译"
git clone -b $autodl_core_branch git@gitlab.seetatech.com:autodl.com/autodl-core.git $seetaas_workspace/src/autodl-core && cd $seetaas_workspace/src/autodl-core/ && export GOPATH=$seetaas_workspace && sed_proxy && make build mode=dev ||echo "重新尝试" && make build mode=dev
}

kpl_frontend(){
echo "拉取kpl前端的$kpl_frontend_branch 分支,并且编译"
git clone -b  $kpl_frontend_branch git@gitlab.seetatech.com:seetaas/seetaas-v3.git $seetaas_workspace/seetaas-v3 && cd $seetaas_workspace/seetaas-v3/ && export GOPATH=$seetaas_workspace && sed_proxy &&  make build mode=dev && rm -rf node_modules
}

kpl_backend(){
echo "拉$kpl_backend_branch 分支 seetaas-backend代码,并且编译"
git clone -b $kpl_backend_branch git@gitlab.seetatech.com:seetaas.com/seetaas-backend.git $seetaas_workspace/src/seetaas-backend && cd $seetaas_workspace/src/seetaas-backend/ && export GOPATH=$seetaas_workspace && sed_proxy && make build -j 7 || echo "重新尝试" && rm -rf $seetaas_workspace/pkg && make build mode=dev

}


kpl_stream(){
echo "拉取$kpl_stream_branch 分支 kpl-stream代码,并且编译"
git clone -b $kpl_stream_branch git@gitlab.seetatech.com:seetaas.com/kpl-stream.git  $seetaas_workspace/src/kpl-stream && cd $seetaas_workspace/src/kpl-stream/ && export GOPATH=$seetaas_workspace && sed_proxy && make build mode=dev || echo "重新尝试" && rm -rf $seetaas_workspace/pkg && make build mode=dev
 
}

kpl_launcher(){
echo "拉取$kpl_launcher_branch 分支 kpl-launcher代码,并且编译"
git clone -b $kpl_launcher_branch  git@gitlab.seetatech.com:tingweiwang/kpl-launcher.git  $seetaas_workspace/src/kpl-launcher
}

kpl_iot(){
echo "拉取$kpl_iot_branch分支的kpl-iot代码,并且编译"

git clone -b $kpl_iot_branch git@gitlab.seetatech.com:seetaas.com/kpl-iot.git $seetaas_workspace/src/kpl-iot && cd $seetaas_workspace/src/kpl-iot/ && export GOPATH=$seetaas_workspace && sed_proxy && make build mode=dev || echo "重新尝试" && rm -rf $seetaas_workspace/pkg && make build mode=dev
 
}

kpl_edu(){
echo "拉取$kpl_edu_branch分支的seetaas-backend代码,修改名为kpl-edu并且编译"

git clone -b $kpl_edu_branch git@gitlab.seetatech.com:seetaas.com/seetaas-backend.git $seetaas_workspace/src/kpl-edu && cd $seetaas_workspace/src/kpl-edu/ && export GOPATH=$seetaas_workspace && sed_proxy && make build mode=dev || echo "重新尝试" && rm -rf $seetaas_workspace/pkg && make build mode=dev
 
}

private_img(){
wget https://2019-10-1.oss-cn-huhehaote.aliyuncs.com/private_images/images.tar.gz -P $base_package_workspace
}

configmap_kpl(){
git clone git@gitlab.seetatech.com:tingweiwang/configmap-kpl.git $base_package_workspace/configmap-kpl
}

seetaas_deploy(){
git clone git@gitlab.seetatech.com:tingweiwang/seetaas-deploy.git $base_package_workspace/seetaas-deploy
}
private_debs(){
wget https://2019-10-1.oss-cn-huhehaote.aliyuncs.com/private_debs/apt-1804/debs-apt-1804.tar.gz -P $base_package_workspace
}

build_seetaas(){
autodl_core
kpl_frontend
kpl_backend  
kpl_stream
kpl_launcher
kpl_iot
kpl_edu
}
echo $kpl_version && sleep 4
###################################
#前面已经删除了setaas项目，此处不要删除了
echo "开始执行seetaas代码打包"
build_seetaas


echo "++++++++++++++删除 $base_package_workspace/seetaas-deploy+++++++++++"
rm -rf $base_package_workspace/seetaas-deploy 
echo "判断是否收集seetaas-deploy脚本"
if [[ $seetaas_deploy_archive == "true" ]];then
     seetaas_deploy
else
     echo "跳过seetaas-deploy任务"
fi


echo "++++++++++++++删除 $base_package_workspace/configmap-kpl +++++++++++"
rm -rf $base_package_workspace/configmap-kpl
echo "判断是否收集configmap-kpl"
if [[ $configmap_kpl_archive == "true" ]];then
     configmap_kpl
else
     echo "跳过收集configmap-kpl任务"
fi


echo "++++++++++++++删除 $base_package_workspace/images.tar.gz +++++++++++"
rm -rf $base_package_workspace/images.tar.gz 
echo "判断是否收集private images"
if [[ $private_images_archive == "true" ]];then
     private_img
else
     echo "跳过收集private images任务"
fi


echo "++++++++++++++删除 $base_package_workspace/debs-apt-1804.tar.gz+++++++++++"
rm -rf $base_package_workspace/debs-apt-1804.tar.gz
echo "判断是否收集private debs"
if [[ $private_apt_debs == "true" ]];then
     private_debs
else
     echo "跳过收集private debs"
fi
echo "删除后端pkg" && rm -rf $seetaas_workspace/pkg ||exit 122
echo "打包收集到的数据目录并移动到本机archive目录"
cd $base_package_workspace && tar -cvzf $archive_package_workspace/deploy-$kpl_version-$date.tar.gz ./* 
echo "将archive的压缩包上传到oss中"
scp $archive_package_workspace/deploy-$kpl_version-$date.tar.gz $oss_path/$oss_project_name/deploy-$kpl_version-$date.tar.gz
echo 你的oss下载地址为：【 https://2019-10-1.oss-cn-huhehaote.aliyuncs.com/$oss_project_name/deploy-$kpl_version-$date.tar.gz 】

